Subject: Re: bug#71518: 30.0.50; Errors during redisplay with c++-ts-mode

From: Vincenzo Pupillo <[email-masked]>
Date: Sat, 22 Jun 2024 16:42:09 +0200

Hi Eli,
fortunately, this time it was easier than usual!

Ciao.
Vincenzo

In data sabato 22 giugno 2024 10:26:43 CEST, Eli Zaretskii ha scritto:
> Ping!  Any progress with this bug?
> 
> > From: Yuan Fu <[email-masked]>
> > Date: Wed, 12 Jun 2024 23:51:21 -0700
> > Cc: [email-masked],
> > 
> >  Bug Report Emacs <[email-masked]>,
> >  Eli Zaretskii <[email-masked]>
> >  
> > > On Jun 12, 2024, at 6:53 AM, Vincenzo Pupillo <[email-masked]>
> > > wrote:> > 
> > > In data mercoledì 12 giugno 2024 14:33:17 CEST, Eli Zaretskii ha 
scritto:
> > >> To reproduce in "emacs -Q", visit some C++ source file (I used
> > >> breakpoint.c from the GDB sources), then turn on c++-ts-mode.  The
> > >> fontification is all incorrect, and *Messages* has these error
> > >> 
> > >> messages:
> > >>  Error during redisplay: (jit-lock-function 7286) signaled
> > >>  (treesit-query-error "Node type error at" 575 "[\"_Atomic\" \"break\"
> > >>  \"case\" \"const\" \"continue\" \"default\" \"do\" \"else\" \"enum\"
> > >>  \"extern\" \"for\" \"goto\" \"if\" \"inline\" \"register\"
> > >>  \"restrict\" \"return\" \"sizeof\" \"static\" \"struct\" \"switch\"
> > >>  \"typedef\" \"union\" \"volatile\" \"while\" \"and\" \"and_eq\"
> > >>  \"bitand\" \"bitor\" \"catch\" \"class\" \"co_await\" \"co_return\"
> > >>  \"co_yield\" \"compl\" \"concept\" \"consteval\" \"constexpr\"
> > >>  \"constinit\" \"decltype\" \"delete\" \"explicit\" \"final\"
> > >>  \"friend\" \"mutable\" \"namespace\" \"new\" \"noexcept\" \"not\"
> > >>  \"not_eq\" \"operator\" \"or\" \"or_eq\" \"override\" \"private\"
> > >>  \"protected\" \"public\" \"requires\" \"template\" \"throw\" \"try\"
> > >>  \"typename\" \"using\" \"virtual\" \"xor\" \"xor_eq\"]
> > >>  @font-lock-keyword-face (auto) @font-lock-keyword-face (this)
> > >>  @font-lock-keyword-face" "Debug the query with
> > >>  `treesit-query-validate'")> >> 
> > >> This happens with the latest C++ tree-sitter grammar library.  I guess
> > >> they made some incompatible change in the grammar or something?
> > > 
> > > Yes, they changed the grammar.
> > > https://github.com/tree-sitter/tree-sitter-cpp/issues/271
> > > 
> > > V.
> > 
> > So it seems “virtual” is now a named node rather than an anonymous node,
> > which is a little odd. I asked the author about it in the GitHub issue,
> > let me clear that up before fixing c-ts-mode.
> > 
> > And, Eli, we really really should pin tree-sitter grammars. As more people
> > start using tree-sitter modes, they will found out about the breakage
> > before we do and the tree-sitter major mode would be unusable for them
> > before they upgrade their grammar. Most of them will not know how to do
> > it and which commit to downgrade to. And I really don’t want to chase the
> > random changes these grammars make all the time. Fixing for these
> > breakages is arguably a heavier maintenance burden than pinning
> > tree-sitter grammars.
> > 
> > Yuan

>From 84c0c0c821b82d59874996cb7bb78e8205fa1377 Mon Sep 17 00:00:00 2001
From: Vincenzo Pupillo <[email-masked]>
Date: Sat, 22 Jun 2024 16:22:16 +0200
Subject: [PATCH] Fix for grammar change of keyword "virtual" in
 tree-sitter-cpp

* lisp/progmodes/c-ts-mode.el (c-ts-mode--keywords):
  Removed the keyword "virtual".
* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
  New font lock rule.
---
 lisp/progmodes/c-ts-mode.el | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

diff --git a/lisp/progmodes/c-ts-mode.el b/lisp/progmodes/c-ts-mode.el
index f453392ff7f..7bfb84baecb 100644
--- a/lisp/progmodes/c-ts-mode.el
+++ b/lisp/progmodes/c-ts-mode.el
@@ -572,7 +572,7 @@ c-ts-mode--keywords
                   "not" "not_eq" "operator" "or"
                   "or_eq" "override" "private" "protected"
                   "public" "requires" "template" "throw"
-                  "try" "typename" "using" "virtual"
+                  "try" "typename" "using"
                   "xor" "xor_eq"))
       (append '("auto") c-keywords))))
 
@@ -632,7 +632,8 @@ c-ts-mode--font-lock-settings
 
    :language mode
    :feature 'keyword
-   `([,@(c-ts-mode--keywords mode)] @font-lock-keyword-face
+   `((virtual) @font-lock-keyword-face
+     [,@(c-ts-mode--keywords mode)] @font-lock-keyword-face
      ,@(when (eq mode 'cpp)
          '((auto) @font-lock-keyword-face
            (this) @font-lock-keyword-face)))
-- 
2.45.2